


      SUBROUTINE CBFMEQ(A,CH,CBQ,DHR,CBTQ,GMA,ALF,AC,BTA,BC,DT,IN)
C        FORMS COEFFICIENTS FOR TRANSIENT LEAKAGE
      DIMENSION A(1),CH(1),CBQ(1),DHR(1),CBTQ(1),GMA(1),ALF(1),AC(1)
     1,BTA(1),BC(1)
      DIMENSION IN(1)
      DIMENSION QOM1(3),QOM2(2)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      IW=MBWC+1
      NVL=2
      NQ=0
      L=0
      DO 50 I=1,NNDS
      IF(GMA(I).LT.1.E-30) GO TO 50
      DTD=GMA(I)*DT
C *** COMPUTE M1 SERIES AND EXPONENTIALLY REDUCE TRANSIENT-LEAKAGE
C     FLUX DUE TO TIME VARIANCE OF AQUIFER HEAD ***
      SM1=0.
      DO 30 NT=1,3
      XP=0.
      TMPA=ALF(NT)*DTD
      IF(TMPA.LT.50.) XP=EXP(-TMPA)
      SM1=SM1+AC(NT)*(1.-XP)
      NQ=NQ+1
      QOM1(NT)=CBTQ(NQ)
      CBTQ(NQ)=XP*CBTQ(NQ)
   30 CONTINUE
C *** COMPUTE NEW TRANSIENT-LEAKAGE FLUX DUE TO TIME VARIANCE OF
C     SOURCE-BED HEAD ***
      DO 40 NT=1,2
      XP=0.
      TMPA=BTA(NT)*DTD
      IF(TMPA.LT.50.) XP=EXP(-TMPA)
      NQ=NQ+1
      QOM2(NT)=CBTQ(NQ)
      CBTQ(NQ)=XP*CBTQ(NQ)+BC(NT)*(1.-XP)*DHR(I)/DTD
   40 CONTINUE
C *** COMPUTE COEFFICIENTS TO ADD INTO MATRIX DIAGONAL AND RIGHT-HAND-
C     SIDE VECTOR ***
      L=L+1
      CH(L)=SM1*A(NVL)/DTD
      CBQ(L)=(2.*(CBTQ(NQ-1)+CBTQ(NQ)-CBTQ(NQ-4)-CBTQ(NQ-3)-CBTQ(NQ-2))
     1+QOM2(1)+QOM2(2)-QOM1(1)-QOM1(2)-QOM1(3))*A(NVL)/3.
   50 NVL=NVL+IW
      RETURN
      END
