


      SUBROUTINE CBTQC(B,DHB,CBTQ,GMA,ALF,AC,DT,IN)
C        COMPUTES NEW TRANSIENT-LEAKAGE FLUX DUE TO TIME VARIANCE OF
C        AQUIFER HEAD
      DIMENSION B(1),DHB(1),CBTQ(1),GMA(1),ALF(1),AC(1)
      DIMENSION IN(1)
      DIMENSION XP(3)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      DTM=3./(2.*DT)
      NQ=-4
      DO 30 I=1,NNDS
      IF(GMA(I).LT.1.E-30) GO TO 30
C *** COMPUTE EXPONENTIAL TERMS FOR M1 SERIES ***
      DTD=GMA(I)*DT
      DO 10 NT=1,3
      XP(NT)=0.
      TMPA=ALF(NT)*DTD
      IF(TMPA.LT.50.) XP(NT)=EXP(-TMPA)
   10 CONTINUE
C *** COMPUTE NEW TRANSIENT-LEAKAGE FLUX ***
      NQ=NQ+5
      K=IN(I)
      IF(K.LT.0) GO TO 20
      TMPA=DTM*B(K)/GMA(I)
      GO TO 25
   20 TMPA=DTM*DHB(-K)/GMA(I)
   25 CBTQ(NQ)=CBTQ(NQ)+AC(1)*(1.-XP(1))*TMPA
      CBTQ(NQ+1)=CBTQ(NQ+1)+AC(2)*(1.-XP(2))*TMPA
      CBTQ(NQ+2)=CBTQ(NQ+2)+AC(3)*(1.-XP(3))*TMPA
   30 CONTINUE
      RETURN
      END
