
      SUBROUTINE DATIN(TITLE,XG,YG,H,DHB,HR,HK,HL,ALPH,QBND,Q,KQB
     1,LQB,IN,IDZ,IDS,NBCZ)
C        READS DATA, SETS UP SOME INITIAL ARRAYS, AND COMPUTES SOME
C        FLOW-BALANCE COMPONENTS FOR BASIC VERSION OF PROGRAM
      DIMENSION TITLE(20),XG(1),YG(1),H(1),DHB(1),HR(1),HK(1),HL(1)
     1,ALPH(1),QBND(1),Q(1)
      DIMENSION KQB(1),LQB(1),IN(1),IDZ(1),IDS(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/IPRN/IPND
      COMMON/IND/IRAD,IUNIT,ISTD
      COMMON/SCLE/SCALE
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
C *** FORMAT LIST ***
    2 FORMAT (I5,7F10.0)
    4 FORMAT (1H0,28X,17HNODAL COORDINATES/1H ,2X,2(4HNODE,5X,7HX COORD
     1,8X,7HY COORD,7X))
    5 FORMAT (1H0,10X,41HNODAL COORDINATES READ, OUTPUT SUPPRESSED)
    6 FORMAT (1H0,29X,13HINITIAL HEADS/1H ,2X,3(4HNODE,8X,4HHEAD,9X))
    7 FORMAT (1H0,10X,37HINITIAL HEADS READ, OUTPUT SUPPRESSED)
    8 FORMAT (1H0,27X,16HSOURCE BED HEADS/1H ,2X,3(4HNODE,8X,4HHEAD,9X))
    9 FORMAT (1H0,10X,40HSOURCE-BED HEADS READ, OUTPUT SUPPRESSED)
   10 FORMAT (1H0,35HSCALE CHANGE FOR NODAL COORDINATES:)
   12 FORMAT (20A4)
   14 FORMAT (1H ,20A4)
   16 FORMAT (8F10.0)
   22 FORMAT (1H0,6X,11HPOINT FLOWS/7H   NODE,5X,9HDISCHARGE)
   23 FORMAT (1H0,10X,35HPOINT FLOWS READ, OUTPUT SUPPRESSED)
   24 FORMAT (1H ,I5,6X,G11.5)
   28 FORMAT (16I5)
   32 FORMAT (1H0,17X,42HCAUCHY-TYPE BOUNDARY DATA BY BOUNDARY ZONE)
   33 FORMAT (1H0,10X,46HCAUCHY-TYPE BOUNDARIES READ, OUTPUT SUPPRESSED)
   34 FORMAT (3I5,4F10.0)
   35 FORMAT (1H0,5X,5HZONE ,I5,4X,9HCONTAINS ,I5,15H BOUNDARY SIDES
     1/1H ,5H SIDE,2X,18HBOUNDARY  BOUNDARY,13X,9HSPECIFIED,5X
     2,8HEXTERNAL,5X,8HEXTERNAL/1H ,5H  NO.,3X,6HNODE A,4X,6HNODE B,3X
     3,5HALPHA,9X,4HFLOW,8X,6HHEAD A,7X,6HHEAD B)
   36 FORMAT (1H ,I4,3X,I5,5X,I5,1X,4(2X,G11.5))
   38 FORMAT (1H0,4X,15HSPECIFIED HEADS/1H ,13X,8HBOUNDARY/7H   NODE,9X
     1,4HHEAD)
   39 FORMAT(1H0,10X,39HSPECIFIED HEADS READ, OUTPUT SUPPRESSED)
   40 FORMAT (1H ,I5,7X,G11.5)
   44 FORMAT (1H0,43H** AXI-SYMMETRIC RADIAL COORDINATES USED **)
   46 FORMAT (1H0,23H** STEADY-STATE FLOW **)
C *** READ INDICATORS FOR RADIAL FLOW, SCALING, AND
C     STEADY-STATE FLOW ***
      READ(IIN,28) IRAD,IUNIT,ISTD
      IF(IRAD.GT.0) WRITE(IOUT,44)
      IF(ISTD.GT.0) WRITE(IOUT,46)
C *** READ AND WRITE NODAL SCALE CHANGE, IF ANY ***
      SCALE=1.
      IF(IUNIT.LE.0) GO TO 60
      WRITE(IOUT,10)
      READ(IIN,12) (TITLE(I),I=1,20)
      WRITE(IOUT,14) (TITLE(I),I=1,20)
      READ(IIN,16) SCALE
C *** READ INDICATOR VARIABLES FOR SUPPRESSING PRINTOUT OF
C     INITIAL CONDITIONS ***
   60 READ(IIN,28) IPXY,IPH,IPHR,IPQW,IPCB,IPHB,IPND
C *** READ AND WRITE NODAL COORDINATES AND INITIAL HEADS ***
      DO 70 J=1,NNDS
      READ(IIN,2) I,XG(I),YG(I),H(I),HR(I)
   70 CONTINUE
      IF(IPXY.GT.0) GO TO 71
      WRITE(IOUT,4)
      CALL PRTOB(XG,YG,NNDS)
      GO TO 72
   71 WRITE(IOUT,5)
   72 IF(IPH.GT.0) GO TO 73
      WRITE(IOUT,6)
      CALL PRTOA(H,NNDS)
      GO TO 74
   73 WRITE(IOUT,7)
   74 IF(IPHR.GT.0) GO TO 75
      WRITE(IOUT,8)
      CALL PRTOA(HR,NNDS)
      GO TO 76
   75 WRITE(IOUT,9)
C *** FOR POINT SOURCES AND SINKS: ***
   76 WQI=0.
      WQO=0.
      IF(NWELS.LE.0) GO TO 100
      IF(IPQW.GT.0) GO TO 77
      WRITE(IOUT,22)
      GO TO 78
   77 WRITE(IOUT,23)
   78 DO 90 I=1,NWELS
C *** (1) READ AND WRITE VALUES ***
      READ(IIN,2) J,QWEL
      IF(IPQW.EQ.0) WRITE(IOUT,24) J,QWEL
C *** (2) COMPUTE TOTAL INFLOW OR OUTFLOW PER UNIT TIME
C     FOR FLOW BALANCE ***
      IF(QWEL.GT.0.) GO TO 85
      WQO=WQO+QWEL
      GO TO 90
   85 WQI=WQI+QWEL
C *** (3) ADD VALUES INTO Q-VECTOR ***
   90 Q(J)=Q(J)+QWEL
C *** READ AND WRITE DATA FOR CAUCHY-TYPE BOUNDARIES ***
  100 IF(NQBND.LE.0) GO TO 130
      IF(IPCB.GT.0) GO TO 101
      WRITE(IOUT,32)
      GO TO 102
  101 WRITE(IOUT,33)
  102 DO 128 NZ=1,NBCZ
      READ(IIN,28) KZ,NOS,IZIN
      IF(IPCB.EQ.0) WRITE(IOUT,35) KZ,NOS
      IDZ(NZ)=KZ
      IDS(KZ)=NOS
      IF(IZIN.GT.0) GO TO 124
      DO 120 I=1,NOS
      READ(IIN,34) J,KQB(J),LQB(J),ALPH(J),QBND(J),HK(J),HL(J)
      IF(IPCB.EQ.0) WRITE(IOUT,36) J,KQB(J),LQB(J),ALPH(J),QBND(J)
     1,HK(J),HL(J)
  120 CONTINUE
      GO TO 128
  124 READ(IIN,16) ALPHZ,QBNZ
      DO 126 I=1,NOS
      READ(IIN,34) J,KQB(J),LQB(J),HK(J),HL(J)
      ALPH(J)=ALPHZ
      QBND(J)=QBNZ
      IF(IPCB.EQ.0) WRITE(IOUT,36) J,KQB(J),LQB(J),ALPH(J),QBND(J)
     1,HK(J),HL(J)
  126 CONTINUE
  128 CONTINUE
C *** INITIALIZE NODAL POINTER ARRAY, IN
  130 DO 134 I=1,NNDS
  134 IN(I)=I
      IN(NNDS+1)=0
      NEQ=NNDS
C *** FOR SPECIFIED-HEAD BOUNDARIES: ***
      IF(NHDS.LE.0) RETURN
      WF=1.
      IF(ISTD.LT.1) WF=2./3.
      IF(IPHB.GT.0) GO TO 135
      WRITE(IOUT,38)
      GO TO 136
  135 WRITE(IOUT,39)
  136 DO 140 I=1,NHDS
C *** (1) READ AND WRITE VALUES ***
      READ(IIN,2) J,HB
      IF(IPHB.EQ.0) WRITE(IOUT,40) J,HB
C *** (2) MODIFY IN TO EXCLUDE SPECIFIED HEAD NODES FROM
C     MATRIX EQUATION ***
      DO 138 K=J,NNDS
  138 IF(IN(K).GT.0) IN(K)=IN(K)-1
      IN(J)=-I
C *** (3) DEFINE HEAD-CHANGE AND MEAN-HEAD VECTORS ***
      DHB(I)=WF*(HB-H(J))
      H(J)=DHB(I)+H(J)
  140 CONTINUE
C *** COMPUTE NUMBER OF SPECIFIED HEADS AT END OF HEAD VECTOR ***
      NLHS=0
      J=NNDS+1
      DO 150 I=1,NNDS
      J=J-1
      IF(IN(J).GT.0) GO TO 160
  150 NLHS=NLHS+1
C *** COMPUTE REDUCED NUMBER OF EQUATIONS ***
  160 NEQ=NNDS-NLHS
      RETURN
      END
