




      SUBROUTINE GNINIT(G,IGCA,IHRK,IHRL,IZRK,IZRL,IZPA,IKRA,ILRA,IKPA
     1,INZA,INSA,NBNC,NPNB,NLCZ)
C        READS DATA, ASSIGNS STORAGE, AND INITIALIZES STORAGE LOCATIONS
C        TO ZERO FOR NONLINEAR CAUCHY-TYPE BOUNDARIES AND NONLINEAR
C        POINT SINKS
      DIMENSION G(1)
      COMMON/GDIM/ISUM
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (16I5)
    4 FORMAT (1H0,54HNO. OF NONLINEAR CAUCHY-TYPE BOUNDARIES (NBNC).....
     $ = ,I5/
     $1H ,54HNO. OF NONLINEAR CAUCHY-TYPE BOUNDARY ZONES (NLCZ). = ,I5/
     $1H ,54HNO. OF NONLINEAR POINT SINKS (NPNB)................ = ,I5)
    6 FORMAT (1H0,64HNONLINEAR CAUCHY-TYPE BOUNDARIES AND (OR) NONLINEAR
     1 POINT SINKS:/1H ,38HNOW G MUST BE DIMENSIONED TO AT LEAST ,I6)
C *** READ AND WRITE NUMBER OF NONLINEAR CAUCHY-TYPE BOUNDARIES AND
C     NONLINEAR POINT SINKS ***
      READ(IIN,2) NBNC,NLCZ,NPNB
      WRITE(IOUT,4) NBNC,NLCZ,NPNB
C *** DEFINE ADDRESSES OF NEW ARRAYS WITHIN G ***
      IGCA=ISUM
      ISUM=ISUM+NBNC+NPNB
      IHRK=ISUM
      ISUM=ISUM+NBNC
      IHRL=ISUM
      ISUM=ISUM+NBNC
      IZRK=ISUM
      ISUM=ISUM+NBNC
      IZRL=ISUM
      ISUM=ISUM+NBNC
      IKRA=ISUM
      ISUM=ISUM+NBNC
      ILRA=ISUM
      ISUM=ISUM+NBNC
      INZA=ISUM
      ISUM=ISUM+NLCZ
      INSA=ISUM
      ISUM=ISUM+NLCZ
      IZPA=ISUM
      ISUM=ISUM+NPNB
      IKPA=ISUM
      ISUM=ISUM+NPNB
C *** WRITE SIZE OF G ***
      WRITE(IOUT,6) ISUM
C *** INITIALIZE G ***
      DO 10 I=IGCA,ISUM
   10 G(I)=0.
      RETURN
      END
