


      SUBROUTINE SWBDMP(B,DSMX,DSP,DSPO,DSPA,RP,ITER)
C        COMPUTES DAMPING PARAMETER AND DAMPS B-VECTOR
      DIMENSION B(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,NIT
      N=NNDS-NHDS
      DSPA=0.
      DSPO=DSP
      DO 10 I=1,N
C *** COMPUTE MAXIMUM ABSOLUTE VALUE OF B-VECTOR ***
      TMPA=ABS(B(I))
      IF(TMPA.LE.DSPA) GO TO 10
      DSPA=TMPA
      DSP=B(I)
   10 CONTINUE
C *** COMPUTE DAMPING PARAMETER, RP ***
      IF(ITER.LE.1) GO TO 30
      SPR=DSP/(RP*DSPO)
      IF(SPR.LT.-1.) GO TO 20
      RP=(3.+SPR)/(3.+ABS(SPR))
      GO TO 30
   20 RP=.5/ABS(SPR)
   30 IF(RP*DSPA.GT.DSMX) RP=DSMX/DSPA
C *** DAMP B-VECTOR ***
      DO 40 I=1,N
   40 B(I)=RP*B(I)
      RETURN
      END
