


      SUBROUTINE SWINIT(G,TOLSW,DSMX,DSP,RP,NITSW,ITKA,ITPA)
C        READS PROBLEM SPECIFICATIONS, DEFINES AND INITIALIZES VARIABLES
C        FOR STEADY-STATE WATER-TABLE AQUIFER VERSION OF PROGRAM
      DIMENSION G(1)
      COMMON/GDIM/ISUM
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,NIT
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (I5,2F10.0)
    4 FORMAT (1H0,54HMAX. NO. OF WATER-TABLE ITERATIONS (NITSW) ........
     $ = ,I5/
     $1H ,54HCLOSURE TOL. FOR WATER-TABLE ITERATIONS (TOLSW) ... = ,
     $ G11.5/
     $1H ,54HMAXIMUM ALLOWABLE DISPLACEMENT (DSMX) ............. = ,
     $ G11.5)
    6 FORMAT ('0STEADY-STATE FLOW IN A WATER-TABLE AQUIFER:',/,
     1' NOW G MUST BE DIMENSIONED TO AT LEAST ',I6)
C *** READ AND WRITE PROBLEM SPECIFICATIONS ***
      READ(IIN,2) NITSW,TOLSW,DSMX
      WRITE(IOUT,4) NITSW,TOLSW,DSMX
C *** DEFINE INITIAL MAXIMUM HEAD DISPLACEMENT AND DAMPING PARAMETER ***
      DSP=DSMX
      RP=1.
C *** DEFINE ADDRESSES OF ARRAYS WITHIN G ***
      ITKA=ISUM
      ISUM=ISUM+NNDS
      ITPA=ISUM
      ISUM=ISUM+NNDS
C *** WRITE NEW SIZE OF G ***
      WRITE(IOUT,6) ISUM
C *** INITIALIZE NEW ELEMENTS OF G ***
      DO 10 I=ITKA,ISUM
   10 G(I)=0.
      RETURN
      END
