


      SUBROUTINE VNCHG(HS,TIME,ISTP)
C        CHANGES VALUES OF CONTROLLING HEAD FOR NONLINEAR STEADY
C        VERTICAL-LEAKAGE FUNCTIONS FOR TIME-VARIANT BOUNDARY CONDITIONS
      DIMENSION HS(1)
      COMMON/CHG/NWCH,NQCH,NHRCH,NBQCH,NHCH,NCBCH,NVNCH,NGNCH
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (16I5)
    4 FORMAT (1H1,11X,37HCHANGES IN VALUES OF CONTROLLING HEAD/1H
     1,10X,38HFOR NONLINEAR STEADY-LEAKAGE FUNCTIONS
     2/1H ,29H  BEGINNING ON TIME STEP NO. ,I4,4H AT ,G11.5
     3,11H TIME UNITS/1H ,34X,11HCONTROLLING/1H ,19X,4HNODE,15X,4HHEAD)
    6 FORMAT (I5,F10.0)
    8 FORMAT (1H ,17X,I5,13X,G11.5)
C *** READ NUMBER OF CONTROLLING HEADS TO BE CHANGED AND TIME-STEP
C     NUMBER FOR NEXT CHANGE ***
      READ(IIN,2) N,NVNCH
C *** WRITE HEADING ***
      WRITE(IOUT,4) ISTP,TIME
C *** READ AND WRITE VALUES OF NEW CONTROLLING HEADS ***
      DO 20 I=1,N
      READ(IIN,6) J,HS(J)
      WRITE(IOUT,8) J,HS(J)
   20 CONTINUE
      RETURN
      END
