



      SUBROUTINE VNFMCO(H,AR,E,HS,ND,NVNZ)
C        READS AND WRITES DATA AND COMPUTES LEAKAGE COEFFICIENTS
C        FOR NONLINEAR STEADY-LEAKAGE FUNCTIONS
      DIMENSION H(1),AR(1),E(1),HS(1)
      DIMENSION ND(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    6 FORMAT (1H0,15X,14HPARAMETERS FOR/1H ,6X,32HNONLINEAR STEADY LEAKA
     1GE BY ZONE/1H ,10X,5HFIRST,5X,6HNO. OF,5X,11HCOEFFICIENT/1H
     2,6H  ZONE,3X,7HEL. NO.,3X,8HELEMENTS,7X,5HVALUE)
    7 FORMAT (1H0,8X,53HNONLINEAR STEADY-LEAKAGE DATA READ, OUTPUT SUPPR
     1ESSED)
    8 FORMAT (3I5,F10.0)
   10 FORMAT (1H ,I5,4X,I5,5X,I5,7X,G11.5)
   12 FORMAT (8F10.0)
   14 FORMAT (1H0,12X,46HCONTROL ELEVATION FOR NONLINEAR STEADY LEAKAGE
     1/1H ,2X,3(4HNODE,7X,5HVALUE,9X))
   15 FORMAT (1H0,8X,70HCONTROL ELEVATION FOR NONLINEAR STEADY LEAKAGE R
     1EAD, OUTPUT SUPPRESSED)
C *** READ INDICATOR VARIABLES FOR SUPPRESSING OUTPUT OF INITIAL VALUES
C     OF NONLINEAR STEADY-LEAKAGE FUNCTIONS ***
      READ(IIN,8) IPNV,IPHS
C *** FOR EACH ZONE SIMULATING NONLINEAR STEADY LEAKAGE: ***
      IF(IPNV.GT.0) GO TO 16
      WRITE(IOUT,6)
      GO TO 18
   16 WRITE(IOUT,7)
   18 DO 40 I=1,NVNZ
C *** (1) READ AND WRITE ZONE DATA ***
      READ(IIN,8) L,NBE,NO,VNCF
      IF(IPNV.EQ.0) WRITE (IOUT,10) L,NBE,NO,VNCF
C *** (2) COMPUTE ELEMENT AND NODE INDICES ***
      NEND=NBE+NO-1
      NDC=4*(NBE-1)+1
      NTE=2*(NBE-1)
C *** FOR EACH ELEMENT IN ZONE I: ***
      DO 30 J=NBE,NEND
      NE=1
C *** (1) CHECK FOR COMBINED INPUT OF NODE NUMBERS FOR TWO ELEMENTS ***
      IF(ND(NDC+3).GT.0) NE=2
C *** (2) COMPUTE LEAKAGE COEFFICIENT, EC, AND STORE IN E-VECTOR
C     BY NODE ***
      DO 20 IE=1,NE
      NA=ND(NDC)
      NB=ND(NDC+IE)
      NC=ND(NDC+IE+1)
      EC=VNCF*AR(NTE+IE)
      E(NA)=E(NA)+EC
      E(NB)=E(NB)+EC
      E(NC)=E(NC)+EC
   20 CONTINUE
      NTE=NTE+2
   30 NDC=NDC+4
   40 CONTINUE
C *** READ AND WRITE CONTROLLING HEAD (OR ELEVATION) ***
      READ(IIN,12) (HS(I),I=1,NNDS)
      IF(IPHS.GT.0) GO TO 42
      WRITE(IOUT,14)
      CALL PRTOA(HS,NNDS)
      RETURN
   42 WRITE(IOUT,15)
      RETURN
      END
