


      SUBROUTINE CBCHG(HR,DHR,TIME,ISTP)
C        READS AND COMPUTES NEW VALUES FOR SOURCE-BED HEAD FOR TRANSIENT
C        LEAKAGE
      DIMENSION HR(1),DHR(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/CHG/NWCH,NQCH,NHRCH,NBQCH,NHCH,NCBCH,NVNCH,NGNCH
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (2I5)
    4 FORMAT (1H1,10X,40HCHANGES IN VALUES OF SOURCE-BED HEAD FOR/1H
     1,2X,57HLEAKAGE INVOLVING TRANSIENT EFFECTS FROM AQUITARD STORAGE
     2/1H ,29H  BEGINNING ON TIME STEP NO. ,I4,4H AT ,G11.5
     3,11H TIME UNITS/1H ,35X,10HSOURCE-BED/1H ,19X,4HNODE,15X,4HHEAD)
    6 FORMAT (1H ,17X,I5,13X,G11.5)
    8 FORMAT (I5,F10.0)
C *** READ NUMBER OF CHANGES AND TIME STEP WHERE CHANGES ARE TO BE
C     MADE AGAIN ***
      READ(IIN,2) N,NCBCH
      WRITE(IOUT,4) ISTP,TIME
      WF=2./3.
      DO 30 I=1,N
C *** READ AND WRITE NEW VALUES ***
      READ(IIN,8) J,HRJ
      WRITE(IOUT,6) J,HRJ
C *** FORM HEAD-CHANGE AND NEW-HEAD VECTORS ***
      DHR(J)=HRJ-HR(J)
   30 HR(J)=WF*DHR(J)+HR(J)
      RETURN
      END
