


      SUBROUTINE CBFMCO(A,AR,GMA,ALF,AC,BTA,BC,WVCN,ND,NCBZ)
C        FORMS COEFFICIENTS FOR TRANSIENT LEAKAGE
      DIMENSION A(1),AR(1),GMA(1),ALF(1),AC(1),BTA(1),BC(1),WVCN(1)
      DIMENSION ND(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (1H0,15X,40HPARAMETERS FOR TRANSIENT LEAKAGE BY ZONE/1H
     1,10X,5HFIRST,5X,6HNO. OF,4X,18HAQUITARD HYDRAULIC,3X
     2,17HAQUITARD SPECIFIC/1H ,6H  ZONE,3X,7HEL. NO.,3X,8HELEMENTS,6X
     3,12HCONDUCTIVITY,11X,7HSTORAGE)
    4 FORMAT (3I5,2F10.0)
    6 FORMAT (1H ,I5,4X,I5,5X,I5,10X,G11.5,8X,G11.5)
C *** DEFINE COEFFICIENTS FOR SERIES APPROXIMATIONS ***
      ALF(1)=13.656
      ALF(2)=436.53
      ALF(3)=49538.
      AC(1)=.26484
      AC(2)=.060019
      AC(3)=.008474
      BTA(1)=10.764
      BTA(2)=19.805
      BC(1)=-.25754
      BC(2)=.090873
      WRITE(IOUT,2)
C *** INITIALIZE NODAL EFFECTIVE AQUITARD HYDRAULIC CONDUCTIVITY ***
      DO 20 I=1,NNDS
   20 WVCN(I)=0.
C *** BEGIN ZONAL LOOP ***
      DO 50 I=1,NCBZ
C *** READ AND WRITE ZONAL DATA ***
      READ(IIN,4) L,NBE,NO,VCON,SPST
      WRITE(IOUT,6) L,NBE,NO,VCON,SPST
C *** BEGIN ELEMENT LOOP WITHIN ZONE ***
      NEND=NBE+NO-1
      NDC=4*(NBE-1)+1
      NTE=2*(NBE-1)
      DO 40 J=NBE,NEND
C *** BEGIN NODAL LOOP WITHIN ELEMENT ***
      NE=1
      IF(ND(NDC+3).GT.0) NE=2
      DO 30 IE=1,NE
C *** COMPUTE EFFECTIVE AQUITARD HYDRAULIC CONDUCTIVITY AND EFFECTIVE
C     AQUITARD SPECIFIC STORAGE ***
      NA=ND(NDC)
      NB=ND(NDC+IE)
      NC=ND(NDC+IE+1)
      TEVC=VCON*AR(NTE+IE)
      WVCN(NA)=WVCN(NA)+TEVC
      WVCN(NB)=WVCN(NB)+TEVC
      WVCN(NC)=WVCN(NC)+TEVC
      TESA=SPST*AR(NTE+IE)
      GMA(NA)=GMA(NA)+TESA
      GMA(NB)=GMA(NB)+TESA
      GMA(NC)=GMA(NC)+TESA
   30 CONTINUE
      NTE=NTE+2
   40 NDC=NDC+4
   50 CONTINUE
C *** COMPUTE GAMMA ***
      IW=MBWC+1
      NVL=2
      DO 60 I=1,NNDS
      IF(GMA(I).GT.1.E-30) GMA(I)=A(NVL)*A(NVL)/(GMA(I)*WVCN(I))
   60 NVL=NVL+IW
      RETURN
      END
