


      SUBROUTINE CBINIT(G,ICHA,ICQA,IDHRA,ICTQA,IGMA,IALFA,IACA,IBTA
     1,IBCA,NCBZ)
C        READS PROBLEM SPECIFICATION, DEFINES AND INITIALIZES VARIABLES
C        FOR TRANSIENT LEAKAGE ROUTINES
      DIMENSION G(1)
      COMMON/GDIM/ISUM
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (1H0,40HTRANSIENT LEAKAGE FROM AQUITARD STORAGE:/1H ,
     1 38HNOW G MUST BE DIMENSIONED TO AT LEAST ,I6)
    4 FORMAT (2I5)
    6 FORMAT (1H0,54HNO. OF AQUITARD PROPERTY ZONES (NCBZ)..............
     1 = ,I5/
     $1H ,54HMAXIMUM NUMBER OF TRANSIENT LEAKAGE NODES (MCBN)... = ,I5)
C *** READ AND WRITE NUMBER OF AQUITARD PROPERTY ZONES AND TRANSIENT
C     LEAKAGE NODES ***
      READ(IIN,4) NCBZ,MCBN
      WRITE(IOUT,6) NCBZ,MCBN
C *** DEFINE ADDRESSES OF NEW ARRAYS WITHIN G ***
      ICHA=ISUM
      ISUM=ISUM+MCBN
      ICQA=ISUM
      ISUM=ISUM+MCBN
      IDHRA=ISUM
      ISUM=ISUM+NNDS
      ICTQA=ISUM
      ISUM=ISUM+5*MCBN
      IGMA=ISUM
      ISUM=ISUM+NNDS
      IALFA=ISUM
      ISUM=ISUM+3
      IACA=ISUM
      ISUM=ISUM+3
      IBTA=ISUM
      ISUM=ISUM+2
      IBCA=ISUM
      ISUM=ISUM+2
C *** WRITE NEW SIZE OF G ***
      WRITE(IOUT,2) ISUM
C *** INITIALIZE NEW ELEMENTS OF G ***
      DO 10 I=ICHA,ISUM
   10 G(I)=0.
      RETURN
      END
