


      SUBROUTINE COCHG(Q,AR,H,HR,DHB,HK,HL,ALPH,QBND,CFDK,CFDL,TIME,KQB
     1,LQB,ND,IN,ISTP)
C        READS AND COMPUTES NEW VALUES OF TIME-VARIANT QUANTITIES
      DIMENSION Q(1),AR(1),H(1),HR(1),DHB(1),HK(1),HL(1),ALPH(1),QBND(1)
     1,CFDK(1),CFDL(1)
      DIMENSION KQB(1),LQB(1),ND(1),IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/CHG/NWCH,NQCH,NHRCH,NBQCH,NHCH,NCBCH,NVNCH,NGNCH
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
C *** FORMAT LIST ***
    2 FORMAT (16I5)
    4 FORMAT (1H1,14X,32HCHANGES IN VALUES OF POINT FLOWS/1H
     1,29H  BEGINNING ON TIME STEP NO. ,I4,4H AT ,G11.5,11H TIME UNITS
     2/1H ,24X,3HOLD,11X,3HNEW/1H ,15X,15HNODE  DISCHARGE,5X
     3,9HDISCHARGE)
    6 FORMAT (I5,4F10.0)
    8 FORMAT (1H ,13X,I5,2(3X,G11.5))
   10 FORMAT (1H1,12X,38HCHANGES IN VALUES OF DISTRIBUTED FLOWS/1H
     1,29H  BEGINNING ON TIME STEP NO. ,I4,4H AT ,G11.5,11H TIME UNITS
     2/1H ,16X,4HBEG.,3X,3HNO.,3X,8HOLD UNIT,6X,8HNEW UNIT/1H ,10X
     3,27HZONE   EL.  ELS.  DISCHARGE,5X,9HDISCHARGE)
   12 FORMAT (3I5,2F10.0)
   14 FORMAT (1H ,7X,3(1X,I5),2(3X,G11.5))
   16 FORMAT (1H1,12X,37HCHANGES IN VALUES OF CAUCHY-TYPE DATA/1H
     1,29H  BEGINNING ON TIME STEP NO. ,I4,4H AT ,G11.5,11H TIME UNITS
     2/1H ,6X,8HEL. SIDE,3X,8HNEW UNIT,6X,8HEXTERNAL,6X,8HEXTERNAL
     3/1H ,9X,3HNO.,5X,9HDISCHARGE,6X,6HHEAD A,8X,6HHEAD B)
   18 FORMAT (1H ,6X,I5,2X,3(3X,G11.5))
   20 FORMAT (1H1,13X,35HCHANGES IN VALUES OF SPECIFIED HEAD/1H
     1,29H  BEGINNING ON TIME STEP NO. ,I4,4H AT ,G11.5,11H TIME UNITS
     2/1H ,19X,4HNODE,15X,4HHEAD)
   22 FORMAT (1H ,17X,I5,13X,G11.5)
   24 FORMAT (1H1,12X,36HCHANGES IN VALUES OF SOURCE-BED HEAD/1H
     1,29H  BEGINNING ON TIME-STEP NO. ,I4,4H AT ,G11.5,11H TIME UNITS
     2/1H ,19X,4HNODE,15X,4HHEAD)
C *** FOR POINT SOURCES AND SINKS: ***
      IF(NWCH.NE.ISTP) GO TO 70
C *** (1) READ NUMBER OF CHANGES AND TIME STEP WHERE CHANGES ARE TO BE
C     MADE AGAIN ***
      READ(IIN,2) N,NWCH
      WRITE(IOUT,4) ISTP,TIME
      DO 60 I=1,N
C *** (2) READ AND WRITE OLD AND NEW VALUES ***
      READ(IIN,6) J,QOLD,QNEW
      WRITE(IOUT,8) J,QOLD,QNEW
C *** (3) ADD VALUES INTO TOTAL INFLOW OR OUTFLOW PER UNIT TIME FOR
C     FLOW BALANCE ***
      IF(QOLD.GT.0.) GO TO 30
      WQO=WQO-QOLD
      GO TO 40
   30 WQI=WQI-QOLD
   40 IF(QNEW.GT.0.) GO TO 50
      WQO=WQO+QNEW
      GO TO 60
   50 WQI=WQI+QNEW
C *** (4) ADD VALUES INTO Q-VECTOR ***
   60 Q(J)=Q(J)+QNEW-QOLD
C *** FOR DISTRIBUTED RECHARGE OR DISCHARGE: ***
   70 IF(NQCH.NE.ISTP) GO TO 152
C *** (1) READ NUMBER OF CHANGES AND TIME STEP WHERE CHANGES ARE TO BE
C     MADE AGAIN ***
      READ(IIN,2) N,NQCH
      WRITE(IOUT,10) ISTP,TIME
C *** (2) READ ELEMENT AREAS AND NODE NUMBERS ***
      REWIND ITB
      M1=2*NELS
      M2=4*NELS
      READ(ITB) (AR(I),I=1,M1),(ND(I),I=1,M2)
      TMPA=0.
      TMPB=0.
      DO 150 I=1,N
C *** (3) READ AND WRITE OLD AND NEW VALUES ***
      READ(IIN,12) L,NBE,NO,QOLD,QNEW
      WRITE(IOUT,14) L,NBE,NO,QOLD,QNEW
C *** (4) BEGIN ELEMENT LOOP ***
      NEND=NBE+NO-1
      NDC=4*(NBE-1)+1
      NTE=2*(NBE-1)
      DO 140 J=NBE,NEND
      NE=1
      IF(ND(NDC+3).GT.0) NE=2
      DO 130 IE=1,NE
      AREA=AR(NTE+IE)
C *** (5) ADD VALUES INTO TOTAL INFLOW OR OUTFLOW PER UNIT TIME FOR
C     FLOW BALANCE ***
      IF(QOLD.GT.0.) GO TO 90
      TMPB=TMPB-QOLD*AREA
      GO TO 100
   90 TMPA=TMPA-QOLD*AREA
  100 IF(QNEW.GT.0.) GO TO 110
      TMPB=TMPB+QNEW*AREA
      GO TO 120
  110 TMPA=TMPA+QNEW*AREA
  120 DQ=(QNEW-QOLD)*AREA
C *** (6) ADD VALUES INTO Q-VECTOR ***
      NA=ND(NDC)
      NB=ND(NDC+IE)
      NC=ND(NDC+IE+1)
      Q(NA)=Q(NA)+DQ
      Q(NB)=Q(NB)+DQ
      Q(NC)=Q(NC)+DQ
  130 CONTINUE
      NTE=NTE+2
  140 NDC=NDC+4
  150 CONTINUE
C *** (7) MODIFY TOTAL INFLOW AND OUTFLOW PER UNIT TIME FOR FLOW
C     BALANCE ***
      DQI=3.*TMPA+DQI
      DQO=3.*TMPB+DQO
C *** FOR SOURCE-BED HEADS: ***
  152 IF(NHRCH.NE.ISTP) GO TO 160
C *** (1) READ NUMBER OF CHANGES AND TIME STEP WHERE CHANGES ARE TO BE
C     MADE AGAIN ***
      READ(IIN,2) N,NHRCH
      WRITE(IOUT,24) ISTP,TIME
      DO 156 I=1,N
C *** (2) READ AND WRITE NEW VALUES ***
      READ (IIN,6) J,HR(J)
      WRITE(IOUT,22) J,HR(J)
  156 CONTINUE
C *** FOR CAUCHY-TYPE BOUNDARIES: ***
  160 IF(NBQCH.NE.ISTP) GO TO 210
C *** (1) READ NUMBER OF CHANGES AND TIME STEP WHERE CHANGES ARE TO BE
C     MADE AGAIN ***
      READ(IIN,2) N,NBQCH
      WRITE(IOUT,16) ISTP,TIME
      DO 200 I=1,N
C *** (2) READ AND WRITE NEW VALUES OF KNOWN FLOW AND KNOWN HEADS ***
      READ(IIN,6) J,QNEW,HK(J),HL(J)
      WRITE(IOUT,18) J,QNEW,HK(J),HL(J)
C *** (3) COMPUTE NEW QBND AND ADD FLOWS INTO Q-VECTOR ***
  195 K=KQB(J)
      L=LQB(J)
      QOLD=QBND(J)
      IF(K.LT.0) GO TO 197
      QBND(J)=QNEW/ALPH(J)
      GO TO 198
  197 K=-K
      QBND(J)=QNEW
  198 Q(K)=Q(K)+(QBND(J)-QOLD)*CFDK(J)
  200 Q(L)=Q(L)+(QBND(J)-QOLD)*CFDL(J)
C *** FOR SPECIFIED-HEAD BOUNDARIES: ***
  210 IF(NHCH.NE.ISTP) RETURN
C *** (1) READ NUMBER OF CHANGES AND TIME STEP WHERE CHANGES ARE TO BE
C     MADE AGAIN ***
      READ(IIN,2) N,NHCH
      WRITE(IOUT,20) ISTP,TIME
      WF=2./3.
      DO 220 I=1,N
C *** (2) READ AND WRITE NEW VALUES ***
      READ(IIN,6) J,HB
      WRITE(IOUT,22) J,HB
C *** (3) FORM HEAD-CHANGE AND NEW-HEAD VECTORS ***
      K=-IN(J)
      DHB(K)=WF*(HB-H(J))
  220 H(J)=DHB(K)+H(J)
      RETURN
      END
