


      SUBROUTINE EXTRAP(H,DHB,B,IN)
C        EXTRAPOLATES HEADS AT ALL NODES FROM THE MEAN POINT IN THE TIME
C        STEP TO THE END OF THE TIME STEP, THEN ZEROES THE HEAD CHANGES
      DIMENSION H(1),DHB(1),B(1)
      DIMENSION IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      DO 30 I=1,NNDS
      J=IN(I)
      IF(J.GT.0) GO TO 20
      J=-J
      H(I)=.5*DHB(J)+H(I)
      DHB(J)=0.
      GO TO 30
   20 H(I)=.5*B(J)+H(I)
      B(J)=0.
   30 CONTINUE
      RETURN
      END
