


      SUBROUTINE GNCHG(HRK,HRL,TIME,KR,LR,ISTP)
C        CHANGES VALUES OF EXTERNAL HEADS FOR NONLINEAR CAUCHY-TYPE
C        BOUNDARIES FOR TIME-VARIANT BOUNDARY CONDITIONS
      DIMENSION HRK(1),HRL(1)
      DIMENSION KR(1),LR(1)
      COMMON/CHG/NWCH,NQCH,NHRCH,NBQCH,NHCH,NCBCH,NVNCH,NGNCH
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (16I5)
    4 FORMAT (1H1,13X,34HCHANGES IN VALUES OF EXTERNAL HEAD
     1/1H ,12X,36HFOR NONLINEAR CAUCHY-TYPE BOUNDARIES
     2/1H ,29H  BEGINNING ON TIME STEP NO. ,I4,4H AT ,G11.5
     3,11H TIME UNITS/1H ,15X,4HSIDE,19X,8HEXTERNAL/1H ,16X,3HNO.,8X
     4,4HNODE,9X,4HHEAD)
    6 FORMAT (I5,2F10.0)
    8 FORMAT (1H ,13X,2(I5,7X),G11.5/1H ,25X,I5,7X,G11.5)
C *** READ NUMBER OF BOUNDARIES TO BE CHANGED AND TIME-STEP NUMBER FOR
C     NEXT CHANGE ***
      READ(IIN,2) N,NGNCH
C *** WRITE HEADING ***
      WRITE(IOUT,4) ISTP,TIME
C *** READ AND WRITE VALUES OF NEW EXTERNAL HEADS ***
      DO 20 I=1,N
      READ(IIN,6) J,HRK(J),HRL(J)
      WRITE(IOUT,8) J,KR(J),HRK(J),LR(J),HRL(J)
   20 CONTINUE
      RETURN
      END
