



      SUBROUTINE SWFMCO(A,THK,TOP,JPT,IN)
C        READS AND WRITES INITIAL AQUIFER THICKNESS AND ELEVATION OF
C        AQUIFER TOP THEN FORMS INITIAL FLOW COEFFICIENTS
      DIMENSION A(1),THK(1),TOP(1)
      DIMENSION JPT(1),IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,NIT
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    4 FORMAT (8F10.0)
    5 FORMAT (16I5)
    6 FORMAT (1H0,24X,25HINITIAL AQUIFER THICKNESS/1H ,3(6H  NODE,5X
     1,9HTHICKNESS,5X))
    7 FORMAT (1H0,8X,49HINITIAL AQUIFER THICKNESS READ, OUTPUT SUPPRESSE
     1D)
    8 FORMAT (1H0,25X,24HELEVATION OF AQUIFER TOP/1H ,3(6H  NODE,5X
     1,9HELEVATION,5X))
    9 FORMAT (1H0,8X,45HAQUIFER TOP ELEVATION READ, OUTPUT SUPPRESSED)
C *** READ AND WRITE INITIAL AQUIFER THICKNESS, THK, AND ELEVATION OF
C     AQUIFER TOP, TOP ***
      READ(IIN,5) IPTK,IPTP
      READ(IIN,4) (THK(I),I=1,NNDS)
      IF(IPTK.GT.0) GO TO 16
      WRITE(IOUT,6)
      CALL PRTOA(THK,NNDS)
      GO TO 17
   16 WRITE(IOUT,7)
   17 READ(IIN,4) (TOP(I),I=1,NNDS)
      IF(IPTP.GT.0) GO TO 18
      WRITE(IOUT,8)
      CALL PRTOA(TOP,NNDS)
      GO TO 19
   18 WRITE(IOUT,9)
C *** COMPUTE INITIAL FLOW COEFFICIENTS, A ***
   19 IW=MBWC+1
      MBM1=MBWC-1
      ND=2
      NP=0
      DO 40 I=1,NNDS
      DO 20 J=1,MBM1
      K=JPT(NP+J)
      IF(IN(K).EQ.0) GO TO 30
   20 A(ND+J)=.5*(THK(K)+THK(I))*A(ND+J)
   30 ND=ND+IW
   40 NP=NP+MBM1
      RETURN
      END
