


      SUBROUTINE SWTHK(H,A,B,Q,THK,TOP,DSPA,TOLSW,JPT,IN,ITER)
C        COMPUTES CURRENT AQUIFER THICKNESS AND FLOW COEFFICIENT ARRAY
      DIMENSION H(1),A(1),B(1),Q(1),THK(1),TOP(1)
      DIMENSION JPT(1),IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,NIT
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
C *** FORMAT LIST ***
    1 FORMAT (1H0,5HNODE ,I5,23H WENT DRY ON ITERATION ,I3/1H ,3X
     1,38HPREDICTED AQUIFER THICKNESS AT NODE = ,G11.5/1H ,3X
     2,19HNET FLOW AT NODE = ,G11.5)
    2 FORMAT (1H ,3X,30HNET FLUX FROM NODE REDUCED TO ,G11.5)
C *** COMPUTE AQUIFER THICKNESS, THK ***
      DO 20 I=1,NNDS
      J=IN(I)
      IF(J.LT.0) GO TO 20
      HO=H(I)-B(J)
      IF(HO.LT.TOP(I)) GO TO 5
      IF(H(I).GT.TOP(I)) GO TO 20
      THK(I)=THK(I)+H(I)-TOP(I)
      GO TO 20
    5 IF(H(I).LT.TOP(I)) GO TO 10
      THK(I)=THK(I)-HO+TOP(I)
      GO TO 20
   10 THK(I)=THK(I)+B(J)
C *** REDUCE DISCHARGE AT NODES THAT ARE DRY ***
      IF(THK(I).GT.0.) GO TO 20
      WRITE(IOUT,1) I,ITER,THK(I),Q(I)
      IF(Q(I).GE.0..OR.B(J).GE.0.) GO TO 20
      Q(I)=.5*Q(I)
      WQO=WQO-Q(I)
      WRITE(IOUT,2) Q(I)
C *** INCREASE MAXIMUM ABSOLUTE DISPLACEMENT TO PERMIT
C     ANOTHER ITERATION USING REDUCED Q VECTOR ***
      DSPA=TOLSW
   20 CONTINUE
C *** COMPUTE FLOW COEFFICIENT ARRAY, A ***
      IW=MBWC+1
      MBM1=MBWC-1
      ND=2
      NP=0
      DO 50 I=1,NNDS
      THKI=THK(I)
      IF(THKI.LT.0.) THKI=0.
      DO 30 J=1,MBM1
      K=JPT(NP+J)
      IF(IN(K).EQ.0) GO TO 40
      THKK=THK(K)
      IF(THKK.LT.0.) THKK=0.
   30 A(ND+J)=.5*(THKK+THKI)*A(ND+J)
   40 ND=ND+IW
   50 NP=NP+MBM1
      RETURN
      END
