


      SUBROUTINE VNINIT(G,IECA,IHSA,NVNZ)
C        READS DATA, ASSIGNS STORAGE, AND INITIALIZES STORAGE LOCATIONS
C        TO ZERO FOR NONLINEAR STEADY-LEAKAGE FUNCTIONS
      DIMENSION G(1)
      COMMON/GDIM/ISUM
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (16I5)
    4 FORMAT (1H0,54HNO. OF NONLINEAR STEADY-LEAKAGE ZONES (NVNZ).......
     1 = ,I5)
    6 FORMAT (1H0,25HNONLINEAR STEADY LEAKAGE:/1H
     1,38HNOW G MUST BE DIMENSIONED TO AT LEAST ,I6)
C *** READ AND WRITE NUMBER OF NONLINEAR STEADY-LEAKAGE ZONES ***
      READ(IIN,2) NVNZ
      WRITE(IOUT,4) NVNZ
C *** DEFINE ADDRESSES OF NEW ARRAYS WITHIN G ***
      IECA=ISUM
      ISUM=ISUM+NNDS
      IHSA=ISUM
      ISUM=ISUM+NNDS
C *** WRITE SIZE OF G ***
      WRITE(IOUT,6) ISUM
C *** INITIALIZE NEW ELEMENTS OF G ***
      DO 10 I=IECA,ISUM
   10 G(I)=0.
      RETURN
      END
