


      SUBROUTINE VNPRED(H,A,B,TOP,E,HS,IN)
C        FORMS COEFFICIENTS FOR NONLINEAR STEADY-LEAKAGE FUNCTIONS;
C        ADDS TERMS TO MATRIX EQUATION FOR THE PREDICTOR
      DIMENSION H(1),A(1),B(1),TOP(1),E(1),HS(1)
      DIMENSION IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      NME=1
C *** FOR EACH NODE I ON THE LEAKAGE BOUNDARY: ***
      DO 40 I=1,NEQ
      K=IN(I)
C *** (1) BYPASS SPECIFIED-HEAD NODES ***
      IF(K.LT.0) GO TO 40
C *** (2) DETERMINE FUNCTION TYPE BY SIGN OF E(I) ***
      IF(E(I)) 5,35,10
C ***
C *** DISCHARGE-ONLY TYPE ***
    5 EI=-E(I)
C *** COMPARE AQUIFER HEAD WITH CONTROLLING ELEVATIONS ***
      IF(H(I).LT.HS(I)) GO TO 35
      IF(H(I).GT.TOP(I)) GO TO 20
      GO TO 15
C ***
C *** STEADY VERTICAL-LEAKAGE TYPE ***
   10 EI=E(I)
C *** COMPARE HEAD WITH AQUIFER TOP ***
      IF(H(I).LT.TOP(I)) GO TO 20
C ***
C *** COMPUTE MAIN DIAGONAL TERM FOR: ***
C *** CASE (4) - DISCHARGE ONLY
C     CASE (1) - STEADY VERTICAL LEAKAGE ***
   15 A(NME)=A(NME)+EI
C *** COMPUTE HEAD DIFFERENCE, TMPA, FOR RIGHT-SIDE TERMS FOR: ***
C *** CASE (4) - DISCHARGE ONLY
C     CASE (1) - STEADY VERTICAL LEAKAGE ***
      TMPA=HS(I)-H(I)
      GO TO 30
C *** CASE (1) - DISCHARGE ONLY ***
C     CASE (4) - STEADY VERTICAL LEAKAGE ***
   20 TMPA=HS(I)-TOP(I)
C *** COMPUTE RIGHT-SIDE LEAKAGE COEFFICIENT AND ADD TO B-VECTOR ***
   30 B(K)=B(K)+EI*TMPA
   35 NME=NME+MBWC
   40 CONTINUE
      RETURN
      END
