      SUBROUTINE WTFMCO(AR,THK,TOP,ASY,ND)
C        FORMS COEFFICIENTS FOR WATER-TABLE AQUIFER
      DIMENSION AR(1),THK(1),TOP(1),ASY(1)
      DIMENSION ND(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    4 FORMAT (8F10.0)
    5 FORMAT (16I5)
    6 FORMAT (1H0,24X,25HINITIAL AQUIFER THICKNESS/1H ,3(6H  NODE,5X
     1,9HTHICKNESS,5X))
    7 FORMAT (1H0,8X,49HINITIAL AQUIFER THICKNESS READ, OUTPUT SUPPRESSE
     1D)
    8 FORMAT (1H0,25X,24HELEVATION OF AQUIFER TOP/1H ,3(6H  NODE,5X
     1,9HELEVATION,5X))
    9 FORMAT (1H0,8X,45HAQUIFER TOP ELEVATION READ, OUTPUT SUPPRESSED)
   10 FORMAT (1H0,6H  ZONE,5X,3HN0.,5X,8HSPECIFIC/1H ,10X,4HELS.,7X
     1,5HYIELD)
   12 FORMAT (2I5,F10.0)
   14 FORMAT (1H ,I5,3X,I5,4X,G11.5)
C *** READ AND WRITE INITIAL AQUIFER THICKNESS ***
      READ(IIN,5) IPTK,IPTP
      READ(IIN,4) (THK(I),I=1,NNDS)
      IF(IPTK.GT.0) GO TO 16
      WRITE(IOUT,6)
      CALL PRTOA(THK,NNDS)
      GO TO 17
   16 WRITE(IOUT,7)
C *** READ AND WRITE INITIAL ELEVATION OF AQUIFER TOP ***
   17 READ(IIN,4) (TOP(I),I=1,NNDS)
      IF(IPTP.GT.0) GO TO 18
      WRITE(IOUT,8)
      CALL PRTOA(TOP,NNDS)
      GO TO 19
   18 WRITE(IOUT,9)
C *** INITIALIZE NODAL SPECIFIC YIELD COEFFICIENTS ***
   19 DO 20 I=1,NNDS
   20 ASY(I)=0.
C *** BEGIN ZONAL LOOP ***
      NDC=1
      NTE=0
      WRITE(IOUT,10)
      DO 50 IZ=1,NZNS
C *** READ AND WRITE ZONAL SPECIFIC YIELD DATA ***
      READ(IIN,12) KZ,NO,SY
      WRITE(IOUT,14) KZ,NO,SY
C *** BEGIN ELEMENT LOOP WITHIN ZONE ***
      DO 40 I=1,NO
      NE=1
      IF(ND(NDC+3).GT.0) NE=2
      DO 30 IE=1,NE
      NA=ND(NDC)
      NB=ND(NDC+IE)
      NC=ND(NDC+IE+1)
C *** COMPUTE NODAL SPECIFIC YIELD COEFFICIENTS ***
      TESY=SY*AR(NTE+IE)
      ASY(NA)=ASY(NA)+TESY
      ASY(NB)=ASY(NB)+TESY
   30 ASY(NC)=ASY(NC)+TESY
      NTE=NTE+2
   40 NDC=NDC+4
   50 CONTINUE
      RETURN
      END
