


      SUBROUTINE XTRPWT(H,DH,DHB,THK,TOP,IN,ISTP)
C        EXTRAPOLATES HEADS AND THICKNESSES AT ALL NODES TO VALUES AT
C        THE END OF THE TIME STEP AND ZEROES HEAD CHANGES
      DIMENSION H(1),DH(1),DHB(1),THK(1),TOP(1)
      DIMENSION IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      DO 60 I=1,NNDS
      J=IN(I)
      IF(J.GT.0) GO TO 20
      J=-J
C *** DEFINE HEAD CHANGE, DHC, AND ZERO HEAD CHANGE VECTORS DHB
C     AND DH ***
      DHC=DHB(J)
      DHB(J)=0.
      GO TO 30
   20 DHC=DH(J)
      DH(J)=0.
   30 HO=H(I)-DHC
C *** EXTRAPOLATE HEAD FROM THE MEAN POINT IN THE TIME STEP TO THE END
C     OF THE TIME STEP ***
      H(I)=.5*DHC+H(I)
C *** EXTRAPOLATE THICKNESS FROM THE BEGINNING TO THE END OF THE TIME
C     STEP ***
      IF(HO.LT.TOP(I)) GO TO 40
      IF(H(I).GT.TOP(I)) GO TO 60
      THK(I)=THK(I)+H(I)-TOP(I)
      GO TO 60
   40 IF(H(I).LT.TOP(I)) GO TO 50
      THK(I)=THK(I)-HO+TOP(I)
      GO TO 60
   50 THK(I)=THK(I)+1.5*DHC
   60 CONTINUE
      RETURN
      END
